#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL
/**
 * @file globus_gsi_callback_constants.h
 * Globus GSI Callback
 * @author Sam Meder, Sam Lang
 *
 * $RCSfile: globus_gsi_callback_constants.h,v $
 * $Revision: 1.3 $
 * $Date: 2003/01/05 00:19:03 $
 */
#endif

#ifndef GLOBUS_GSI_CALLBACK_CONSTANTS_H
#define GLOBUS_GSI_CALLBACK_CONSTANTS_H

/**
 * @defgroup globus_gsi_callback_constants GSI Callback Constants
 */
/**
 * GSI Callback Error codes
 * @ingroup globus_gsi_callback_constants
 */
typedef enum
{
    GLOBUS_GSI_CALLBACK_ERROR_SUCCESS = 0,
    GLOBUS_GSI_CALLBACK_ERROR_VERIFY_CRED = 1,
    GLOBUS_GSI_CALLBACK_ERROR_CERT_NOT_YET_VALID = 2,
    GLOBUS_GSI_CALLBACK_ERROR_CANT_GET_LOCAL_CA_CERT = 3,
    GLOBUS_GSI_CALLBACK_ERROR_CERT_HAS_EXPIRED = 4,
    GLOBUS_GSI_CALLBACK_ERROR_INVALID_PROXY = 5,
    GLOBUS_GSI_CALLBACK_ERROR_LIMITED_PROXY = 6,
    GLOBUS_GSI_CALLBACK_ERROR_INVALID_CRL = 7,
    GLOBUS_GSI_CALLBACK_ERROR_REVOKED_CERT = 8,
    GLOBUS_GSI_CALLBACK_ERROR_VERIFYING_NEW_PROXY = 9,
    GLOBUS_GSI_CALLBACK_ERROR_WITH_SIGNING_POLICY = 10,
    GLOBUS_GSI_CALLBACK_ERROR_OLD_GAA = 11,
    GLOBUS_GSI_CALLBACK_ERROR_CALLBACK_DATA = 12,
    GLOBUS_GSI_CALLBACK_ERROR_ERRNO = 13,
    GLOBUS_GSI_CALLBACK_ERROR_CERT_CHAIN = 14,
    GLOBUS_GSI_CALLBACK_ERROR_WITH_CALLBACK_DATA_INDEX = 15,
    GLOBUS_GSI_CALLBACK_ERROR_PROXY_PATH_LENGTH_EXCEEDED = 16,
    GLOBUS_GSI_CALLBACK_ERROR_MIXING_DIFFERENT_PROXY_TYPES = 17,
    GLOBUS_GSI_CALLBACK_ERROR_LAST = 18

} globus_gsi_callback_error_t;

#endif /* GLOBUS_GSI_CALLBACK_CONSTANTS_H */

