/* $Id: globus_i_replica_management.h,v 1.10 2001/07/30 22:15:17 quesnel Exp $ */

#ifndef GLOBUS_DONT_DOCUMENT_INTERNAL

/**
 * @file
 *
 * Globus Replica Management Internal C API Header File
 */

#ifndef _GLOBUS_I_REPLICA_MANAGEMENT_H
#define _GLOBUS_I_REPLICA_MANAGEMENT_H

#ifdef __cplusplus
#define EXTERN_C_BEGIN extern "C" {
#define EXTERN_C_END }
#else
#define EXTERN_C_BEGIN
#define EXTERN_C_END
#endif

EXTERN_C_BEGIN

/**
 * Enumeration of operation strings
 */

#define GLOBUS_I_REPLICA_MANAGEMENT_DELETE    "delete"
#define GLOBUS_I_REPLICA_MANAGEMENT_COPY      "copy"
#define GLOBUS_I_REPLICA_MANAGEMENT_PUBLISH   "publish"


#define GLOBUS_I_REPLICA_MANAGEMENT_PHYSICAL_DELETE_START "physical delete start"
#define GLOBUS_I_REPLICA_MANAGEMENT_LOGICAL_DELETE_START  "logical delete start"
#define GLOBUS_I_REPLICA_MANAGEMENT_NEED_PHYSICAL_DELETE  "need physical delete"
#define GLOBUS_I_REPLICA_MANAGEMENT_SAFE_START            "safe start"
#define GLOBUS_I_REPLICA_MANAGEMENT_UNSAFE_START          "unsafe start"
#define GLOBUS_I_REPLICA_MANAGEMENT_NEED_FILE_MOVE        "need file move"
#define GLOBUS_I_REPLICA_MANAGEMENT_NEED_FILE_MOVE        "need file move"
#define GLOBUS_I_REPLICA_MANAGEMENT_NEED_PREREGISTER      "need preregister"
#define GLOBUS_I_REPLICA_MANAGEMENT_NEED_COLLECTION_ADD   "need collection add"
#define GLOBUS_I_REPLICA_MANAGEMENT_NEED_LOCATION_ADD     "need location add"

/**
 * Collection connection cache entry.
 */
typedef struct globus_l_replica_management_cache_entry_s
{
    /** LDAP URL of the collection */
    char *                                              url;

    /** collection connection handle */
    globus_replica_catalog_collection_handle_t *        handle;

    /** collection connection handle attributes */
    globus_replica_catalog_collection_handleattr_t      attrs;
}
globus_l_replica_management_cache_entry_t;



globus_result_t
globus_i_replica_management_set_plugin_data(
    globus_replica_management_handle_t *    handle,
    char *                                  location_name,
    char *                                  filename);

globus_result_t
globus_i_replica_management_plugin_data_init(
    globus_replica_management_handle_t *    handle);

typedef struct globus_i_replica_management_monitor_s
{
    globus_mutex_t                              mutex;
    globus_cond_t                               cond;
    globus_bool_t                               done;
    globus_result_t                             result;
    globus_size_t                               bytes_read;
}
globus_i_replica_management_monitor_t;

globus_result_t
globus_i_replica_management_monitor_init(
    globus_i_replica_management_monitor_t *     monitor);

globus_result_t
globus_i_replica_management_monitor_reset(
    globus_i_replica_management_monitor_t *     monitor);

globus_result_t
globus_i_replica_management_monitor_destroy(
    globus_i_replica_management_monitor_t *     monitor);


EXTERN_C_END

#endif /* _GLOBUS_I_REPLICA_MANAGEMENT_H */

#endif /* GLOBUS_DONT_DOCUMENT_INTERNAL */

